#include "dec_img.h"


#include "../imgencodedecode/encode.h"
#include "../fileformat/imagefile.h"				//private head file

#define ITEM_PHOENIX_TOOLS 	  "PXTOOLS "


#define min( x, y )          ( (x) < (y) ? (x) : (y) )
#define max( x, y )          ( (x) > (y) ? (x) : (y) )

#define HEAD_ID				0		//ͷܽӿ
#define TABLE_ID			1		//ܽӿ
#define DATA_ID				2		//ݼܽӿ
#define IF_CNT				3		//ܽӿڸ	ֻͷܣܣݼ3
#define	MAX_KEY_SIZE 		32		//볤

#pragma pack(push, 1)
typedef struct tag_IMAGE_HANDLE
{

	CSzFile      * fp;			//ļ

	ImageHead_t  ImageHead;		//imgͷϢ

	ImageItem_t *ItemTable;		//itemϢ

	RC_ENDECODE_IF_t rc_if_decode[IF_CNT];//ܽӿ
	
	__bool			bWithEncpy; // Ƿ
	
}IMAGE_HANDLE;

#define INVALID_INDEX		0xFFFFFFFF

#pragma pack(push, 1)
typedef struct tag_ITEM_HANDLE{
	__u32	index;					//ItemTableе
	__u64 pos;
}ITEM_HANDLE;
#pragma pack(pop)

static  __u8 *buffer_encode;
static  int   buffer_encode_size;

//------------------------------------------------------------------------------------------------------------
//
// ˵
//
//
// ˵
//
//
// ֵ
//
//
// 
//    
//
//------------------------------------------------------------------------------------------------------------
HIMAGE 	Img_Open	(__u32 start_sector, int size)
{
	IMAGE_HANDLE  *pImage;
	ImageHead_t ImageHead;
	char	seed[]	= "img";
	char key_buff[MAX_KEY_SIZE];
	__u32 key_len = MAX_KEY_SIZE;
	__u32 ItemTableSize;
	__u8 * ItemTableBuf, * pItemTableDecode;
	__u32 i;

    pImage = (IMAGE_HANDLE *)sprite_malloc(sizeof(IMAGE_HANDLE));
    if(!pImage)
    {
        sprite_wrn("DEC_IMG: fail to get memory for pImage\n");

        return NULL;
    }
	memset(pImage, 0, sizeof(IMAGE_HANDLE));
	buffer_encode_size = size;
	//------------------------------------------------
	//ʼܽӿ
	//------------------------------------------------
	for (i = 0; i< IF_CNT; i++)
	{
		pImage->rc_if_decode[i].handle 		= NULL;
		pImage->rc_if_decode[i].Initial		= Initial;
		pImage->rc_if_decode[i].EnDecode	= Decode;
		pImage->rc_if_decode[i].UnInitial	= UnInitial;
		memset(key_buff, i, key_len);		//ǰݳʼΪ0 note
		key_buff[key_len - 1] = seed[i];	//һֽ޸    note

		pImage->rc_if_decode[i].handle = pImage->rc_if_decode[i].Initial(key_buff, &key_len, i);
		if (NULL == pImage->rc_if_decode[i].handle)
		{
		    sprite_free(pImage);
		    sprite_wrn("DEC_IMG: pImage->rc_if_decode[i].handle is NULL\n");

			return NULL;
		}
	}
	//------------------------------------------------
	//imgļ
	//------------------------------------------------
	pImage->fp = File_Open(start_sector, 0, 4, 0);
	if (NULL == pImage->fp)
	{
	    sprite_free(pImage);
		sprite_wrn("DEC_IMG: open img file failed\n");

		return NULL;
	}

	//------------------------------------------------
	//imgͷ
	//------------------------------------------------
	if(File_Read(&ImageHead, sizeof(ImageHead_t), 1, pImage->fp))
	{
        
	    sprite_free(pImage);
		sprite_wrn("DEC_IMG: read imagehead fail!\n");

        return  NULL;

    }
     
	if(memcmp(ImageHead.magic, IMAGE_MAGIC, 8) == 0)
	{
		pImage->bWithEncpy = 0;
       // sprite_wrn("DEC_IMG: no encpy used!\n");
	}
	else
	{
		pImage->bWithEncpy = 1;
       // sprite_wrn("DEC_IMG:  encpy used!\n");
	}
	
	if(pImage->bWithEncpy)
	{
    	__u8 * pHead = (__u8 *) &ImageHead;
    	__u8 * pHeadDecode = (__u8 *)&pImage->ImageHead;
    	__u8 * pin, *pout;

    	for (i = 0; i < sizeof(ImageHead_t); i+= ENCODE_LEN)
    	{
    		pin = pHead + i;
    		pout= pHeadDecode + i;
    		if (OK  != pImage->rc_if_decode[HEAD_ID].EnDecode(pImage->rc_if_decode[HEAD_ID].handle, pin , pout))
    		{
    		    sprite_free(pImage);
    			File_Close(pImage->fp);
    			sprite_wrn("DEC_IMG: decode img file head failed\n");

    			return NULL;
    		}
    	}
    }
    else
    {
        memcpy((void *)(&(pImage->ImageHead)), (void*)&ImageHead, sizeof(ImageHead_t));
    }
	//------------------------------------------------
	//Ƚmagic
	//------------------------------------------------
	//sprite_wrn("DEC_IMG: img header magic:%s\n",pImage->ImageHead.magic);
	if (memcmp(pImage->ImageHead.magic, IMAGE_MAGIC, 8))
	{
	    sprite_free(pImage);
		File_Close(pImage->fp);
		sprite_wrn("DEC_IMG: img header magic error\n");

		return NULL;
	}
	ItemTableSize = pImage->ImageHead.itemcount * sizeof(ImageItem_t);
	pImage->ItemTable = (ImageItem_t*)sprite_malloc(ItemTableSize);
	if(!pImage->ItemTable)
	{
	    sprite_free(pImage);
		File_Close(pImage->fp);
		sprite_wrn("DEC_IMG: fail to get memory for ItemTable\n");

		return NULL;
	}

	//------------------------------------------------
	//read ItemTable
	//------------------------------------------------
	ItemTableBuf = (__u8 *)sprite_malloc(ItemTableSize);
	if(!ItemTableBuf)
	{
	    sprite_free(pImage->ItemTable);
	    sprite_free(pImage);
		File_Close(pImage->fp);
		sprite_wrn("DEC_IMG: fail to get memory for ItemTableBuf\n");

		return NULL;
	}
  //  sprite_wrn("DEC_IMG: pImage->ImageHead.itemoffset=0x%x\n",pImage->ImageHead.itemoffset);
  // sprite_wrn("DEC_IMG: pImage->ImageHead.itemSize=0x%x\n",pImage->ImageHead.itemsize);
  //  sprite_wrn("DEC_IMG: pImage->ImageHead.itemcount=%d\n",pImage->ImageHead.itemcount);
    
	File_Seek(pImage->fp, pImage->ImageHead.itemoffset, SZ_SEEK_SET);
	if(File_Read(ItemTableBuf, ItemTableSize, 1, pImage->fp))
	{
		sprite_wrn("DEC_IMG: read ItemTable failed\n");
	    return 0;
	}
	File_Seek(pImage->fp, 0, SZ_SEEK_CUR);
	//------------------------------------------------
	// decode ItemTable
	//------------------------------------------------
	pItemTableDecode = (__u8 *)pImage->ItemTable;
    if(pImage->bWithEncpy)
	{
	    __u8 *pin, *pout;

    	for (i = 0; i < ItemTableSize; i+= ENCODE_LEN)
    	{
    		pin = ItemTableBuf + i;
    		pout= pItemTableDecode + i;

    		if (OK  != pImage->rc_if_decode[TABLE_ID].EnDecode(pImage->rc_if_decode[TABLE_ID].handle, pin , pout))
    		{
    		    sprite_free(pImage->ItemTable);
    		    sprite_free(ItemTableBuf);
    			File_Close(pImage->fp);
    			sprite_free(pImage);
    			sprite_wrn("DEC_IMG: decode img file ItemTable failed\n");

    			return NULL;
    		}
    	}
    }else
	{
	
		memcpy(pItemTableDecode, ItemTableBuf, ItemTableSize);
	
	}
	
    sprite_free(ItemTableBuf);

    buffer_encode = (__u8 *)sprite_malloc(buffer_encode_size);
    if(!buffer_encode)
    {
        sprite_free(pImage->ItemTable);
	    sprite_free(ItemTableBuf);
		File_Close(pImage->fp);
		sprite_free(pImage);
		sprite_wrn("DEC_IMG: fail to get memory for buffer_encode\n");

		return NULL;
    }

	return pImage;
}



//------------------------------------------------------------------------------------------------------------
//
// ˵
//
//
// ˵
//
//
// ֵ
//
//
// 
//    
//
//------------------------------------------------------------------------------------------------------------
HIMAGEITEM 	Img_OpenItem	(HIMAGE hImage, char * MainType, char * subType)
{
	IMAGE_HANDLE* pImage = (IMAGE_HANDLE *)hImage;
	ITEM_HANDLE * pItem  = NULL;
	__u32 i;

	pItem = (ITEM_HANDLE *)sprite_malloc(sizeof(ITEM_HANDLE));
	if(!pItem)
	{
		sprite_wrn("DEC_IMG: fail to get memory for pItem\n");
	    return NULL;
	}

	pItem->index = INVALID_INDEX;
	pItem->pos = 0;

	for (i = 0; i < pImage->ImageHead.itemcount ; i++)
	{
    //  sprite_wrn("pImage->ItemTable[%d].mainType=%s,subType=%s\n",i,pImage->ItemTable[i].mainType,\
    //    pImage->ItemTable[i].subType);
        if (memcmp(ITEM_PHOENIX_TOOLS, MainType, MAINTYPE_LEN) == 0)//
		{
			if (memcmp(MainType, pImage->ItemTable[i].mainType, MAINTYPE_LEN) == 0 )
			{
				pItem->index = i;
				return pItem;
			}
		}
		else if (memcmp(MainType, pImage->ItemTable[i].mainType, MAINTYPE_LEN) == 0 &&
		         memcmp(subType,  pImage->ItemTable[i].subType,  SUBTYPE_LEN)  == 0)
		{
			pItem->index = i;
			return pItem;
		}
	}

	sprite_free(pItem);
	pItem = NULL;

	return NULL;
}



//------------------------------------------------------------------------------------------------------------
//
// ˵
//
//
// ˵
//
//
// ֵ
//
//
// 
//    
//
//------------------------------------------------------------------------------------------------------------
__u64 Img_GetItemSize	(HIMAGE hImage, HIMAGEITEM hItem)
{
    IMAGE_HANDLE *pImage = (IMAGE_HANDLE *)hImage;
    ITEM_HANDLE  *pItem  = (ITEM_HANDLE  *)hItem;
    __u64      nItemSize;

 	nItemSize  = pImage->ItemTable[pItem->index].filelenLo;
    nItemSize |= (__u64)pImage->ItemTable[pItem->index].filelenHi << 32;
//	return pImage->ItemTable[pItem->index].filelen;
  	return nItemSize;
    //еһܣ˶ᰴշ
}


//------------------------------------------------------------------------------------------------------------
//
// ˵
//
//
// ˵
//
//
// ֵ
//     ʵʶȡݵĳ
//
// 
//    
//
//------------------------------------------------------------------------------------------------------------

static __u32 __Img_ReadItemData(HIMAGE hImage, HIMAGEITEM hItem, void * buffer, __u64 Length);

// ݷмٴİ汾 scott 2009-06-22 10:37:17
__u32 Img_ReadItemData(HIMAGE hImage, HIMAGEITEM hItem, void * buffer, __u64 Length)
{
	__u32 readlen = 0;
	IMAGE_HANDLE* pImage = (IMAGE_HANDLE *)hImage;
	ITEM_HANDLE * pItem  = (ITEM_HANDLE  *)hItem;
    __u64      filelen;
    __u64      datalen;
    __u64      offset;
    __u64      pos=0;
	__u32 this_read;
	__u32 i;

    pEnDecode pfDecode = pImage->rc_if_decode[DATA_ID].EnDecode;
	u8* pInPutBuffer = (u8*)buffer;
	u8* pBufferRead = pInPutBuffer ;
    filelen  = pImage->ItemTable[pItem->index].filelenLo;
    filelen |= (__u64)pImage->ItemTable[pItem->index].filelenHi << 32;
	if (pItem->pos >=filelen) //filelen <= datalen
	{
		sprite_wrn("DEC_IMG: file pointer position is larger than file length\n");
		return 0;
	}
	//------------------------------------------------
	//ԼݲᳬݵķΧ
	//------------------------------------------------
	datalen  = pImage->ItemTable[pItem->index].datalenLo;
    datalen |= (__u64)pImage->ItemTable[pItem->index].datalenHi << 32;
	Length = min((__u64)Length, datalen - pItem->pos);
	//------------------------------------------------
	//ܺ16byteз飬Ҫ߽
	//------------------------------------------------
	if ((pItem->pos % ENCODE_LEN) == 0)	//posǷı߽
	{
	    __u8 *pin, *pout;
	    __u32 n;

	    offset  = pImage->ItemTable[pItem->index].offsetLo;
        offset |= (__u64)pImage->ItemTable[pItem->index].offsetHi << 32;
       // __inf("item offset low=%d\n",pImage->ItemTable[pItem->index].offsetLo);
       // __inf("item offset high=%d\n",pImage->ItemTable[pItem->index].offsetHi);
        pos = offset + pItem->pos;
		File_Seek(pImage->fp, pos, SZ_SEEK_SET);
		readlen = 0;
		while(readlen < Length)
		{
			//------------------------------------------------
			//ÿζȡn
			//------------------------------------------------
			this_read = min(buffer_encode_size, (Length - readlen));
			n = (this_read + ENCODE_LEN - 1) / ENCODE_LEN;	//
			//memset(buffer_encode, 0, n * ENCODE_LEN);
			//һζn,ٶȸ note has bug
			if(pImage->bWithEncpy == 0)
			{
				pBufferRead = pInPutBuffer + readlen;
				if(File_Read(pBufferRead, n * ENCODE_LEN, 1, pImage->fp))	//OK ͨȡķ
           		 {
                	//
                	sprite_wrn("DEC_IMG: read ItemData failed\n");
                	return 0;
            	 }
			
			}else
			{
			
			
				if(File_Read(buffer_encode, n * ENCODE_LEN, 1, pImage->fp))	//OK ͨȡķ
           		 {
            	    //
               		 sprite_wrn("DEC_IMG: read ItemData failed\n");
               		 return 0;
            	 }
				File_Seek(pImage->fp, 0, SZ_SEEK_CUR);
				//------------------------------------------------
				//ݽ
				//------------------------------------------------
				pin  = buffer_encode;
				pout = (__u8 *)buffer;
				pout = pout + readlen;	//ʵݵƫ

				for (i = 0; i < n; i++)	//н
				{
					//------------------------------------------------
					//ÿνһ
					//------------------------------------------------
					if (OK !=  pfDecode(pImage->rc_if_decode[DATA_ID].handle, pin , pout))
					{
						sprite_wrn("DEC_IMG: decode ItemData failed\n");
						return 0;
					}
					pin += ENCODE_LEN;
					pout+= ENCODE_LEN;
				}
			}
			//------------------------------------------------
			//ʵЧݳ
			//------------------------------------------------
			readlen += this_read;
		}
		pItem->pos += readlen;
		return readlen;
	}
	else
	{
		//------------------------------------------------
		//ǿֻǰһЩ̼ܻ𲻼ݵ⣬
		//ֻԭʼ汾
		//------------------------------------------------
		sprite_wrn("__Img_ReadItemData\n");
		return  __Img_ReadItemData(hImage, hItem,  buffer, Length);
	}

	//return 0;
}


//ԭʼİ汾Уÿζimgļ16byteٶȲߣҪ
__u32 __Img_ReadItemData(HIMAGE hImage, HIMAGEITEM hItem, void * buffer, __u64 Length)
{

	IMAGE_HANDLE* pImage = (IMAGE_HANDLE *)hImage;
	ITEM_HANDLE * pItem  = (ITEM_HANDLE  *)hItem;
    __u64      filelen;
    __u64      datalen;
    __u64      offset;
    __u64      pos=0;
    __u64      readlen=0;
	__u8 buffer_encode[ENCODE_LEN];


	pEnDecode pfDecode = pImage->rc_if_decode[DATA_ID].EnDecode;
	if (NULL == pImage || NULL == pItem || NULL == buffer || 0 == Length)
	{
		return 0;
	}

   	filelen  = pImage->ItemTable[pItem->index].filelenLo;
    filelen |= (__u64)pImage->ItemTable[pItem->index].filelenHi << 32;
	if (pItem->pos >=filelen) //filelen <= datalen
	{
		return 0;
	}
	//------------------------------------------------
	//ԼݲᳬݵķΧ
	//------------------------------------------------
	datalen = pImage->ItemTable[pItem->index].datalenLo;
    datalen |= (__u64)pImage->ItemTable[pItem->index].datalenHi << 32;
	Length = min((__u64)Length, datalen - pItem->pos);
	if(pImage->bWithEncpy == 0)
	{
   		offset = pImage->ItemTable[pItem->index].offsetLo;
        offset |= (__u64)pImage->ItemTable[pItem->index].offsetHi << 32;
        pos = offset + pItem->pos;
		File_Seek(pImage->fp, pos, SZ_SEEK_SET);
        
		if(File_Read(buffer, Length, 1, pImage->fp))
		{
			return 0;
		}
		pItem->pos += Length;
		return Length;
	}

	//------------------------------------------------
	//ܺ16byteз飬Ҫ߽
	//------------------------------------------------
	if ((pItem->pos % ENCODE_LEN) == 0)	//posǷı߽
	{
	    __u8 *pin, *pout;

   		 offset = pImage->ItemTable[pItem->index].offsetLo;
        offset |= (__u64)pImage->ItemTable[pItem->index].offsetHi << 32;
        pos = offset + pItem->pos;

		File_Seek(pImage->fp, pos, SZ_SEEK_SET);

		while(readlen < Length)
		{
			//ÿζȡһ
			//memset(buffer_encode, 0, ENCODE_LEN);
			if(File_Read(buffer_encode, ENCODE_LEN, 1, pImage->fp))
			{
			    return 0;
			}
			File_Seek(pImage->fp, 0, SZ_SEEK_CUR);
			//ݽ
			pin = buffer_encode;
			pout= (__u8 *)buffer;
			pout= pout + readlen;
			if (OK != pfDecode(pImage->rc_if_decode[DATA_ID].handle, pin , pout))
				return 0;
			//ʵЧݳ
			readlen += min(Length- readlen, ENCODE_LEN);
		}
		pItem->pos += readlen;
		return readlen;
	}
	else //posڱ߽
	{
		//posڱ߽磬ͷseek

        offset = pImage->ItemTable[pItem->index].offsetLo;
        offset |= (__u64)pImage->ItemTable[pItem->index].offsetHi << 32;		
		pos = offset +pItem->pos - (pItem->pos % ENCODE_LEN);
		File_Seek(pImage->fp, pos, SZ_SEEK_SET);

		//-----------------------------------
		//**********************OOOOOOOOOOOOO     *ʾѾȡ Oʾδȡ
		//-----------------------------------
		if ((0 < Length) && (Length < ENCODE_LEN)) //ȡݲһ鳤
		{
		    __u8 *pin, *pout;
			__u32 read = ENCODE_LEN - (pItem->pos % ENCODE_LEN); //δȡݳ
			if (Length <= read)	//ҪȡСڵڷδȡݳ ֻöһ鼴
			{
				//memset(buffer_encode, 0, ENCODE_LEN);
				if(File_Read(buffer_encode, ENCODE_LEN, 1, pImage->fp))
				{
				    return 0;
				}
				//ݽ
				pin = buffer_encode;
				pout= (__u8 *)buffer;
				pout     = pout + readlen;
				if (OK != pfDecode(pImage->rc_if_decode[DATA_ID].handle, pin , pout))
					return 0;

				readlen = Length;
				pItem->pos += readlen;
				return readlen;
			}
			else //Ҫ
			{
				//һ
				__u8 *pin, *pout;
				__u32 Left_Length;
				__u32 read = ENCODE_LEN - pItem->pos % ENCODE_LEN;
				//memset(buffer_encode, 0, ENCODE_LEN);
				if(File_Read(buffer_encode, ENCODE_LEN, 1, pImage->fp))
				{
				    return 0;
				}
				//ݽ
				pin  = buffer_encode;
				pout = (__u8 *)buffer;
				pout = pout + readlen;
				if (OK != pfDecode(pImage->rc_if_decode[DATA_ID].handle, pin , pout))
					return 0;

				readlen += read;

				//ڶ
				Left_Length = Length - read;			//ʣ
				//memset(buffer_encode, 0, ENCODE_LEN);
				if(File_Read(buffer_encode, ENCODE_LEN, 1, pImage->fp))
				{
				    return 0;
				}
				File_Seek(pImage->fp, 0, SZ_SEEK_CUR);
				//ݽ
				pin = buffer_encode;
				pout= (__u8 *)buffer;
				pout     = pout + readlen;
				if (OK != pfDecode(pImage->rc_if_decode[DATA_ID].handle, pin , pout))
					return 0;
				readlen += Left_Length;

				pItem->pos += readlen;
				return readlen;
			}
		}
		else if (Length >= ENCODE_LEN) //ȡݲһ鳤
		{
			__u8 *pin, *pout;
			__u32 Left_Length, Left_readlen;
			__u32 read = ENCODE_LEN - pItem->pos % ENCODE_LEN;
			//memset(buffer_encode, 0, ENCODE_LEN);
			if(File_Read(buffer_encode, ENCODE_LEN, 1, pImage->fp))
			{
			    return 0;
			}
			//ݽ
			pin = buffer_encode;
			pout= (__u8 *)buffer;
			pout     = pout + readlen;
			if (OK != pfDecode(pImage->rc_if_decode[DATA_ID].handle, pin , pout))
				return 0;

			readlen += read;

			//------------------------------------------------
			//ʣݰշд
			//------------------------------------------------
			Left_Length = Length - read;
			Left_readlen= 0;
			while(Left_readlen < Left_Length)
			{
				//ÿζȡһ
				//memset(buffer_encode, 0, ENCODE_LEN);
				if(File_Read(buffer_encode, ENCODE_LEN, 1, pImage->fp))
				{
				    return 0;
				}
				File_Seek(pImage->fp, 0, SZ_SEEK_CUR);
				//ݽ
				pin = buffer_encode;
				pout= (__u8 *)buffer;
				pout     = pout + readlen;
				if (OK != pfDecode(pImage->rc_if_decode[DATA_ID].handle, pin , pout))
					return 0;
				//ʵЧݳ
				Left_readlen += min(Left_Length - Left_readlen, ENCODE_LEN);
			}

			readlen += Left_readlen;
		}

		pItem->pos += readlen;
		return readlen;
	}

//	return 0;
}



//------------------------------------------------------------------------------------------------------------
//
// ˵
//
//
// ˵
//
//
// ֵ
//
//
// 
//    
//
//------------------------------------------------------------------------------------------------------------
__u32 Img_CloseItem	(HIMAGE hImage, HIMAGEITEM hItem)
{
	ITEM_HANDLE * pItem = (ITEM_HANDLE *)hItem;
	if (NULL == pItem)
		return __LINE__;

	pItem = NULL;

	return OK;
}



//------------------------------------------------------------------------------------------------------------
//
// ˵
//
//
// ˵
//
//
// ֵ
//
//
// 
//    
//
//------------------------------------------------------------------------------------------------------------
void  Img_Close	(HIMAGE hImage)
{
	IMAGE_HANDLE * pImage = (IMAGE_HANDLE *)hImage;

	if (NULL != pImage->fp)
	{
		File_Close(pImage->fp);
		pImage->fp = NULL;
	}

	if (NULL != pImage->ItemTable)
	{
		pImage->ItemTable = NULL;
	}

	memset(pImage, 0, sizeof(IMAGE_HANDLE));
	pImage = NULL;

	if(buffer_encode)
	{
	    sprite_free(buffer_encode);
    }
	return ;
}


//------------------------------------------------------------------------------------------------------------
// THE END !
//------------------------------------------------------------------------------------------------------------



